--luacheck: ignore GUNBELTCOUNT
require("util")
local gunbelt = {}
local Player = require("player")

local guninv = defines.inventory.player_guns
local ammoinv = defines.inventory.player_ammo

local function get_next_belt(cur_belt)
  if cur_belt >= GUNBELTCOUNT then
    return 1
  else
    return (cur_belt + 1)
  end
end

--local function get_inventories(player)


function gunbelt.save_current_belt(player_index)
  local player, data = Player.get_data(player_index)
  local gun_inv, ammo_inv = player.get_inventory(guninv), player.get_inventory(ammoinv)
  if not (gun_inv and ammo_inv) then
    player.print("No gun inventory found")
    return
  end

  data.gun_belt[data.cur_belt] = {}
  local belt = data.gun_belt[data.cur_belt]

  for i=1, #gun_inv do
    belt[i] = {}
    if gun_inv[i] and gun_inv[i].valid_for_read then
      belt[i].gun = {
        name = gun_inv[i].name
      }
    else
      belt[i].gun = {}
    end
    if ammo_inv and ammo_inv[i].valid_for_read then
      belt[i].ammo = {
        name = ammo_inv[i].name,
        count = ammo_inv[i].count,
        magazine = ammo_inv[i].ammo,
      }
    else
      belt[i].ammo = {}
    end
  end
  --game.print(serpent.block(belt, {comment=false}))
end

function gunbelt.load_belt(player_index, belt_num)
  local player, data = Player.get_data(player_index)
  local gun_inv, ammo_inv = player.get_inventory(guninv), player.get_inventory(ammoinv)

  if not (gun_inv and ammo_inv) then
    player.print({"error.no-gunammo-inv"})
    return
  end

  gunbelt.save_current_belt(player.index)
  data.cur_belt = belt_num or get_next_belt(tonumber(data.cur_belt))
  player.print({"info.equiping-belt ",  data.cur_belt})

  gun_inv.clear()
  ammo_inv.clear()

  local gun_belt = data.gun_belt[data.cur_belt]

  if gun_belt then
    player.print(tostring(#gun_belt))
    for i=1, #gun_belt do
      if gun_belt[i].gun and gun_belt[i].gun.name then
        gun_inv[i].set_stack({name = gun_belt[i].gun.name, count = 1})
      end
      if gun_belt[i].ammo and gun_belt[i].ammo.name then
        ammo_inv[i].set_stack({name=gun_belt[i].ammo.name, count = gun_belt[i].ammo.count})
        ammo_inv[i].ammo = gun_belt[i].ammo.magazine
      end
    end
  end
end




function gunbelt.cycle(event)
  gunbelt.load_belt(event.player_index)
end

function gunbelt.select_belt(event)
  gunbelt.load_belt(event.player_index, tonumber(string.match(event.input_name, "%d")))
end

function gunbelt.init(player_index)
  gunbelt.save_current_belt(player_index) --not really necessaary unless doing custom gui?
end

--Register controls related events
if GUNBELTCOUNT > 1 then
  local gun_belt_select_events = {}
  script.on_event("gun-belt-cycle", gunbelt.cycle)
  for i = 1, 5 do
    if i <= GUNBELTCOUNT then gun_belt_select_events[i]="gun-belt-select-"..i end
  end
  script.on_event(gun_belt_select_events, gunbelt.select_belt)
end

return gunbelt
