local Player = {}

function Player.init(player_index)
  global.player_data = global.player_data or {}
  if not global.player_data[player_index] then
    global.player_data[player_index] = {
      gun_belt = {},
      cur_belt = 1,
    }
  end
end

function Player.init_all_players()
  for _, player in pairs(game.players) do
    Player.init(player.index)
  end
end


--- Returns the player object table and the players global object table.
-- @param player_index the index of the player
-- @return player, data table
function Player.get_data(player_index)
  if not (global.player_data and global.player_data[player_index]) then
    Player.init(player_index)
  end
  local player = game.players[player_index]
  local data = global.player_data[player_index]
  return player, data
end

---Iterate a list of objects and return true if all are valid and connected
-- @param ... array of objs to check if valid
-- @return bool are all objects valid
function Player.is_valid(...)
  local valid = false
  for _, obj in pairs({...}) do
    if obj and obj.valid then
      valid = true
      if obj == "player" and not obj.connected then
        return false
      end
    else
      return false
    end
  end
  return valid
end

function Player.get_item_stack(player)
  local stack
  if player.cursor_stack and player.cursor_stack.valid_for_read then
    stack = player.cursor_stack
  end
  return stack
end

return Player
